Subject: Re: bug#57962: 29.0.50; Odd font choices

From: Po Lu <[email-masked]>
Date: Wed, 21 Sep 2022 10:19:37 +0800

Lars Ingebrigtsen <[email-masked]> writes:

> I'm not sure when this started happening, but probably not more than a
> month ago.
>
> An image to illustrate the problem:
>
>
>
>
>>>From "emacs -Q" (but not with my normal font choices), the font used for
> the help-key-binding face is larger than the rest of the text, making
> various things kinda ugly.
>
> The normal text uses:
>
>     ftcrhb:-DAMA-Ubuntu Mono-regular-normal-normal-*-45-*-*-*-m-0-iso10646-1 (#x55)
>
> The keyboard text is:
>
>     ftcrhb:-PfEd-DejaVu Sans Mono-regular-normal-normal-*-45-*-*-*-m-0-iso10646-1 (#x52)
>
> And the help-key-binding face is:
>
> (defface help-key-binding
>   '((((class color) (min-colors 88) (background light))
> [...]
>      :inherit fixed-pitch)
>
> and
>
> (defface fixed-pitch
>   '((t :family "Monospace"))
>   "The basic fixed-pitch face."
>   :group 'basic-faces)
>
> So this chooses a different font than
>
> (defface default
>   '((t nil)) ; If this were nil, face-defface-spec would not be set.
>   "Basic default face."
>   :group 'basic-faces)
>
> ?

Yes, "Monospace" is mapped to a special font family by fontconfig,
sometimes different than the monospace font specified via xsettings.

I think the best thing to do would be to change fixed-pitch to be
affected by xsettings as well, but I'm not quite sure how to go about
doing that.